constexpr byte VramWidth = 32;
constexpr byte VramHeight = 24;
constexpr byte CharHeight = 8;
constexpr byte PatternSize = CharHeight;
constexpr word VramRowSize = VramWidth;
constexpr byte VramStep = 1;

constexpr ptr<byte> Vram = (ptr<byte>)0x1400;
constexpr ptr<byte> CharRam = (ptr<byte>)0x1000;

extern void VVramToVram();
extern void ClearScreen();
extern ptr<byte> VramPtr(byte x, byte y);
extern ptr<byte> PrintC(ptr<byte> pVram, byte c);

extern void SetPatternMono(ptr<byte> pSource, byte pattern, byte color, byte count);
extern void SetPatternColor(ptr<byte> pSource, byte pattern, byte count);
extern void CopyPattern(byte c, byte pattern, byte count);

extern void InitVram();
extern void WriteVram4(ptr<byte> pVram, ptr<byte> pCodes);
extern void Put4C(byte x, byte y, byte c);
